<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CalendarEventSearchRow StructType
 * @subpackage Structs
 */
class CalendarEventSearchRow extends SearchRow
{
    /**
     * The basic
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CalendarEventSearchRowBasic
     */
    public $basic;
    /**
     * The attendeeJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EntitySearchRowBasic
     */
    public $attendeeJoin;
    /**
     * The attendeeContactJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\ContactSearchRowBasic
     */
    public $attendeeContactJoin;
    /**
     * The attendeeCustomerJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\CustomerSearchRowBasic
     */
    public $attendeeCustomerJoin;
    /**
     * The caseJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\SupportCaseSearchRowBasic
     */
    public $caseJoin;
    /**
     * The fileJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\FileSearchRowBasic
     */
    public $fileJoin;
    /**
     * The opportunityJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\OpportunitySearchRowBasic
     */
    public $opportunityJoin;
    /**
     * The originatingLeadJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\OriginatingLeadSearchRowBasic
     */
    public $originatingLeadJoin;
    /**
     * The timeJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TimeBillSearchRowBasic
     */
    public $timeJoin;
    /**
     * The transactionJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\TransactionSearchRowBasic
     */
    public $transactionJoin;
    /**
     * The userJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\EmployeeSearchRowBasic
     */
    public $userJoin;
    /**
     * The userNotesJoin
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\NoteSearchRowBasic
     */
    public $userNotesJoin;
    /**
     * The customSearchJoin
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\CustomSearchRowBasic[]
     */
    public $customSearchJoin;
    /**
     * Constructor method for CalendarEventSearchRow
     * @uses CalendarEventSearchRow::setBasic()
     * @uses CalendarEventSearchRow::setAttendeeJoin()
     * @uses CalendarEventSearchRow::setAttendeeContactJoin()
     * @uses CalendarEventSearchRow::setAttendeeCustomerJoin()
     * @uses CalendarEventSearchRow::setCaseJoin()
     * @uses CalendarEventSearchRow::setFileJoin()
     * @uses CalendarEventSearchRow::setOpportunityJoin()
     * @uses CalendarEventSearchRow::setOriginatingLeadJoin()
     * @uses CalendarEventSearchRow::setTimeJoin()
     * @uses CalendarEventSearchRow::setTransactionJoin()
     * @uses CalendarEventSearchRow::setUserJoin()
     * @uses CalendarEventSearchRow::setUserNotesJoin()
     * @uses CalendarEventSearchRow::setCustomSearchJoin()
     * @param \StructType\CalendarEventSearchRowBasic $basic
     * @param \StructType\EntitySearchRowBasic $attendeeJoin
     * @param \StructType\ContactSearchRowBasic $attendeeContactJoin
     * @param \StructType\CustomerSearchRowBasic $attendeeCustomerJoin
     * @param \StructType\SupportCaseSearchRowBasic $caseJoin
     * @param \StructType\FileSearchRowBasic $fileJoin
     * @param \StructType\OpportunitySearchRowBasic $opportunityJoin
     * @param \StructType\OriginatingLeadSearchRowBasic $originatingLeadJoin
     * @param \StructType\TimeBillSearchRowBasic $timeJoin
     * @param \StructType\TransactionSearchRowBasic $transactionJoin
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @param \StructType\NoteSearchRowBasic $userNotesJoin
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     */
    public function __construct(\StructType\CalendarEventSearchRowBasic $basic = null, \StructType\EntitySearchRowBasic $attendeeJoin = null, \StructType\ContactSearchRowBasic $attendeeContactJoin = null, \StructType\CustomerSearchRowBasic $attendeeCustomerJoin = null, \StructType\SupportCaseSearchRowBasic $caseJoin = null, \StructType\FileSearchRowBasic $fileJoin = null, \StructType\OpportunitySearchRowBasic $opportunityJoin = null, \StructType\OriginatingLeadSearchRowBasic $originatingLeadJoin = null, \StructType\TimeBillSearchRowBasic $timeJoin = null, \StructType\TransactionSearchRowBasic $transactionJoin = null, \StructType\EmployeeSearchRowBasic $userJoin = null, \StructType\NoteSearchRowBasic $userNotesJoin = null, array $customSearchJoin = array())
    {
        $this
            ->setBasic($basic)
            ->setAttendeeJoin($attendeeJoin)
            ->setAttendeeContactJoin($attendeeContactJoin)
            ->setAttendeeCustomerJoin($attendeeCustomerJoin)
            ->setCaseJoin($caseJoin)
            ->setFileJoin($fileJoin)
            ->setOpportunityJoin($opportunityJoin)
            ->setOriginatingLeadJoin($originatingLeadJoin)
            ->setTimeJoin($timeJoin)
            ->setTransactionJoin($transactionJoin)
            ->setUserJoin($userJoin)
            ->setUserNotesJoin($userNotesJoin)
            ->setCustomSearchJoin($customSearchJoin);
    }
    /**
     * Get basic value
     * @return \StructType\CalendarEventSearchRowBasic|null
     */
    public function getBasic()
    {
        return $this->basic;
    }
    /**
     * Set basic value
     * @param \StructType\CalendarEventSearchRowBasic $basic
     * @return \StructType\CalendarEventSearchRow
     */
    public function setBasic(\StructType\CalendarEventSearchRowBasic $basic = null)
    {
        $this->basic = $basic;
        return $this;
    }
    /**
     * Get attendeeJoin value
     * @return \StructType\EntitySearchRowBasic|null
     */
    public function getAttendeeJoin()
    {
        return $this->attendeeJoin;
    }
    /**
     * Set attendeeJoin value
     * @param \StructType\EntitySearchRowBasic $attendeeJoin
     * @return \StructType\CalendarEventSearchRow
     */
    public function setAttendeeJoin(\StructType\EntitySearchRowBasic $attendeeJoin = null)
    {
        $this->attendeeJoin = $attendeeJoin;
        return $this;
    }
    /**
     * Get attendeeContactJoin value
     * @return \StructType\ContactSearchRowBasic|null
     */
    public function getAttendeeContactJoin()
    {
        return $this->attendeeContactJoin;
    }
    /**
     * Set attendeeContactJoin value
     * @param \StructType\ContactSearchRowBasic $attendeeContactJoin
     * @return \StructType\CalendarEventSearchRow
     */
    public function setAttendeeContactJoin(\StructType\ContactSearchRowBasic $attendeeContactJoin = null)
    {
        $this->attendeeContactJoin = $attendeeContactJoin;
        return $this;
    }
    /**
     * Get attendeeCustomerJoin value
     * @return \StructType\CustomerSearchRowBasic|null
     */
    public function getAttendeeCustomerJoin()
    {
        return $this->attendeeCustomerJoin;
    }
    /**
     * Set attendeeCustomerJoin value
     * @param \StructType\CustomerSearchRowBasic $attendeeCustomerJoin
     * @return \StructType\CalendarEventSearchRow
     */
    public function setAttendeeCustomerJoin(\StructType\CustomerSearchRowBasic $attendeeCustomerJoin = null)
    {
        $this->attendeeCustomerJoin = $attendeeCustomerJoin;
        return $this;
    }
    /**
     * Get caseJoin value
     * @return \StructType\SupportCaseSearchRowBasic|null
     */
    public function getCaseJoin()
    {
        return $this->caseJoin;
    }
    /**
     * Set caseJoin value
     * @param \StructType\SupportCaseSearchRowBasic $caseJoin
     * @return \StructType\CalendarEventSearchRow
     */
    public function setCaseJoin(\StructType\SupportCaseSearchRowBasic $caseJoin = null)
    {
        $this->caseJoin = $caseJoin;
        return $this;
    }
    /**
     * Get fileJoin value
     * @return \StructType\FileSearchRowBasic|null
     */
    public function getFileJoin()
    {
        return $this->fileJoin;
    }
    /**
     * Set fileJoin value
     * @param \StructType\FileSearchRowBasic $fileJoin
     * @return \StructType\CalendarEventSearchRow
     */
    public function setFileJoin(\StructType\FileSearchRowBasic $fileJoin = null)
    {
        $this->fileJoin = $fileJoin;
        return $this;
    }
    /**
     * Get opportunityJoin value
     * @return \StructType\OpportunitySearchRowBasic|null
     */
    public function getOpportunityJoin()
    {
        return $this->opportunityJoin;
    }
    /**
     * Set opportunityJoin value
     * @param \StructType\OpportunitySearchRowBasic $opportunityJoin
     * @return \StructType\CalendarEventSearchRow
     */
    public function setOpportunityJoin(\StructType\OpportunitySearchRowBasic $opportunityJoin = null)
    {
        $this->opportunityJoin = $opportunityJoin;
        return $this;
    }
    /**
     * Get originatingLeadJoin value
     * @return \StructType\OriginatingLeadSearchRowBasic|null
     */
    public function getOriginatingLeadJoin()
    {
        return $this->originatingLeadJoin;
    }
    /**
     * Set originatingLeadJoin value
     * @param \StructType\OriginatingLeadSearchRowBasic $originatingLeadJoin
     * @return \StructType\CalendarEventSearchRow
     */
    public function setOriginatingLeadJoin(\StructType\OriginatingLeadSearchRowBasic $originatingLeadJoin = null)
    {
        $this->originatingLeadJoin = $originatingLeadJoin;
        return $this;
    }
    /**
     * Get timeJoin value
     * @return \StructType\TimeBillSearchRowBasic|null
     */
    public function getTimeJoin()
    {
        return $this->timeJoin;
    }
    /**
     * Set timeJoin value
     * @param \StructType\TimeBillSearchRowBasic $timeJoin
     * @return \StructType\CalendarEventSearchRow
     */
    public function setTimeJoin(\StructType\TimeBillSearchRowBasic $timeJoin = null)
    {
        $this->timeJoin = $timeJoin;
        return $this;
    }
    /**
     * Get transactionJoin value
     * @return \StructType\TransactionSearchRowBasic|null
     */
    public function getTransactionJoin()
    {
        return $this->transactionJoin;
    }
    /**
     * Set transactionJoin value
     * @param \StructType\TransactionSearchRowBasic $transactionJoin
     * @return \StructType\CalendarEventSearchRow
     */
    public function setTransactionJoin(\StructType\TransactionSearchRowBasic $transactionJoin = null)
    {
        $this->transactionJoin = $transactionJoin;
        return $this;
    }
    /**
     * Get userJoin value
     * @return \StructType\EmployeeSearchRowBasic|null
     */
    public function getUserJoin()
    {
        return $this->userJoin;
    }
    /**
     * Set userJoin value
     * @param \StructType\EmployeeSearchRowBasic $userJoin
     * @return \StructType\CalendarEventSearchRow
     */
    public function setUserJoin(\StructType\EmployeeSearchRowBasic $userJoin = null)
    {
        $this->userJoin = $userJoin;
        return $this;
    }
    /**
     * Get userNotesJoin value
     * @return \StructType\NoteSearchRowBasic|null
     */
    public function getUserNotesJoin()
    {
        return $this->userNotesJoin;
    }
    /**
     * Set userNotesJoin value
     * @param \StructType\NoteSearchRowBasic $userNotesJoin
     * @return \StructType\CalendarEventSearchRow
     */
    public function setUserNotesJoin(\StructType\NoteSearchRowBasic $userNotesJoin = null)
    {
        $this->userNotesJoin = $userNotesJoin;
        return $this;
    }
    /**
     * Get customSearchJoin value
     * @return \StructType\CustomSearchRowBasic[]|null
     */
    public function getCustomSearchJoin()
    {
        return $this->customSearchJoin;
    }
    /**
     * This method is responsible for validating the values passed to the setCustomSearchJoin method
     * This method is willingly generated in order to preserve the one-line inline validation within the setCustomSearchJoin method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $calendarEventSearchRowCustomSearchJoinItem) {
            // validation for constraint: itemType
            if (!$calendarEventSearchRowCustomSearchJoinItem instanceof \StructType\CustomSearchRowBasic) {
                $invalidValues[] = is_object($calendarEventSearchRowCustomSearchJoinItem) ? get_class($calendarEventSearchRowCustomSearchJoinItem) : sprintf('%s(%s)', gettype($calendarEventSearchRowCustomSearchJoinItem), var_export($calendarEventSearchRowCustomSearchJoinItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic[] $customSearchJoin
     * @return \StructType\CalendarEventSearchRow
     */
    public function setCustomSearchJoin(array $customSearchJoin = array())
    {
        // validation for constraint: array
        if ('' !== ($customSearchJoinArrayErrorMessage = self::validateCustomSearchJoinForArrayConstraintsFromSetCustomSearchJoin($customSearchJoin))) {
            throw new \InvalidArgumentException($customSearchJoinArrayErrorMessage, __LINE__);
        }
        $this->customSearchJoin = $customSearchJoin;
        return $this;
    }
    /**
     * Add item to customSearchJoin value
     * @throws \InvalidArgumentException
     * @param \StructType\CustomSearchRowBasic $item
     * @return \StructType\CalendarEventSearchRow
     */
    public function addToCustomSearchJoin(\StructType\CustomSearchRowBasic $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\CustomSearchRowBasic) {
            throw new \InvalidArgumentException(sprintf('The customSearchJoin property can only contain items of type \StructType\CustomSearchRowBasic, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->customSearchJoin[] = $item;
        return $this;
    }
}
